local e=require("nixio.fs")
local t=require("luci.model.uci").cursor()
local a=require("luci.http")
local e=require("luci.util")
local n=e.split(e.trim(e.exec("ls /etc/travelmate/*.login 2>/dev/null")),"\n",nil,true)or{}
m=SimpleForm("edit",translate("Edit Wireless Uplink Configuration"))
m.submit=translate("Save")
m.cancel=translate("Back to overview")
m.reset=false
function m.on_cancel()
a.redirect(luci.dispatcher.build_url("admin/services/travelmate/stations"))
end
m.hidden={
cfg=a.formvalue("cfg")
}
local e=t:get_all("wireless",m.hidden.cfg)
if e~=nil then
wssid=m:field(Value,"ssid",translate("SSID"))
wssid.datatype="rangelength(1,32)"
wssid.default=e.ssid or""
bssid=m:field(Value,"bssid",translate("BSSID"))
bssid.datatype="macaddr"
bssid.default=e.bssid or""
if string.match(e.encryption,'%+')and not string.match(e.encryption,'^wep')then
e.pos=string.find(e.encryption,'%+')
e.cipher=string.sub(e.encryption,e.pos+1)
e.encryption=string.sub(e.encryption,0,e.pos-1)
end
if e.encryption and e.encryption~="none"then
if string.match(e.encryption,'^wep')then
encr=m:field(ListValue,"encryption",translate("Encryption"))
encr:value("wep","WEP")
encr:value("wep+open","WEP Open System")
encr:value("wep+mixed","WEP mixed")
encr:value("wep+shared","WEP Shared Key")
encr.default=e.encryption
wkey=m:field(Value,"key",translate("Passphrase"))
wkey.datatype="wepkey"
wkey.password=true
wkey.default=e.key
elseif string.match(e.encryption,'^wpa')then
encr=m:field(ListValue,"encryption",translate("Encryption"))
encr:value("wpa","WPA Enterprise")
encr:value("wpa-mixed","WPA/WPA2 Enterprise mixed")
encr:value("wpa2","WPA2 Enterprise")
encr.default=e.encryption
ciph=m:field(ListValue,"cipher",translate("Cipher"))
ciph:value("auto",translate("Automatic"))
ciph:value("ccmp",translate("Force CCMP (AES)"))
ciph:value("tkip",translate("Force TKIP"))
ciph:value("tkip+ccmp",translate("Force TKIP and CCMP (AES)"))
ciph.default=e.cipher
eaptype=m:field(ListValue,"eap_type",translate("EAP-Method"))
eaptype:value("tls","TLS")
eaptype:value("ttls","TTLS")
eaptype:value("peap","PEAP")
eaptype:value("fast","FAST")
eaptype.default=e.eap_type or"peap"
authentication=m:field(ListValue,"auth",translate("Authentication"))
authentication:value("PAP")
authentication:value("CHAP")
authentication:value("MSCHAP")
authentication:value("MSCHAPV2")
authentication:value("EAP-GTC")
authentication:value("EAP-MD5")
authentication:value("EAP-MSCHAPV2")
authentication:value("EAP-TLS")
authentication:value("auth=PAP")
authentication:value("auth=MSCHAPV2")
authentication.default=e.auth or"EAP-MSCHAPV2"
ident=m:field(Value,"identity",translate("Identity"))
ident.default=e.identity or""
wkey=m:field(Value,"password",translate("Passphrase"))
wkey.datatype="wpakey"
wkey.password=true
wkey.default=e.password
cacert=m:field(Value,"ca_cert",translate("Path to CA-Certificate"))
cacert.rmempty=true
cacert.default=e.ca_cert or""
clientcert=m:field(Value,"client_cert",translate("Path to Client-Certificate"))
clientcert:depends("eap_type","tls")
clientcert.rmempty=true
clientcert.default=e.client_cert or""
privkey=m:field(Value,"priv_key",translate("Path to Private Key"))
privkey:depends("eap_type","tls")
privkey.rmempty=true
privkey.default=e.priv_key or""
privkeypwd=m:field(Value,"priv_key_pwd",translate("Password of Private Key"))
privkeypwd:depends("eap_type","tls")
privkeypwd.datatype="wpakey"
privkeypwd.password=true
privkeypwd.rmempty=true
privkeypwd.default=e.priv_key_pwd or""
else
encr=m:field(ListValue,"encryption",translate("Encryption"))
encr:value("psk","WPA-PSK")
encr:value("psk2","WPA2-PSK")
encr:value("psk-mixed","WPA/WPA2 mixed")
encr:value("sae","WPA3-SAE")
encr:value("owe","OWE (open network)")
encr:value("sae-mixed","WPA2/WPA3 mixed")
encr.default=e.encryption
ciph=m:field(ListValue,"cipher",translate("Cipher"))
ciph:value("auto",translate("Automatic"))
ciph:value("ccmp",translate("Force CCMP (AES)"))
ciph:value("tkip",translate("Force TKIP"))
ciph:value("tkip+ccmp",translate("Force TKIP and CCMP (AES)"))
ciph:depends("encryption","psk")
ciph:depends("encryption","psk2")
ciph:depends("encryption","psk-mixed")
ciph.default=e.cipher or"auto"
wkey=m:field(Value,"key",translate("Passphrase"))
wkey.datatype="wpakey"
wkey.password=true
wkey:depends("encryption","psk")
wkey:depends("encryption","psk2")
wkey:depends("encryption","psk-mixed")
wkey:depends("encryption","sae")
wkey:depends("encryption","sae-mixed")
wkey.default=e.key
end
end
else
m.on_cancel()
end
local a=(e.device or"").."_"..(e.ssid or"").."_"..(e.bssid or"")
a=a:gsub("[^%w_]","_")
local i=t:get("travelmate",a,"command")
local o=t:get("travelmate",a,"command_args")
cmd_list=m:field(ListValue,"cmdlist",translate("Auto Login Script"),
translate("External script reference which will be called for automated captive portal logins."))
cmd_args=m:field(Value,"cmdargs",translate("Optional Arguments"),
translate("Space separated list of additional arguments passed to the Auto Login Script, i.e. username and password"))
for t,e in ipairs(n)do
cmd_list:value(e)
cmd_args:depends("cmdlist",e)
end
cmd_list:value("none")
cmd_list.default=i or"none"
cmd_args.default=o
function wssid.write(o,e,o)
t:set("wireless",m.hidden.cfg,"ssid",wssid:formvalue(e))
t:set("wireless",m.hidden.cfg,"bssid",bssid:formvalue(e))
if encr then
if string.find(encr:formvalue(e),'^wep')then
t:set("wireless",m.hidden.cfg,"encryption",encr:formvalue(e))
t:set("wireless",m.hidden.cfg,"key",wkey:formvalue(e)or"")
elseif string.find(encr:formvalue(e),'^wpa')then
t:set("wireless",m.hidden.cfg,"eap_type",eaptype:formvalue(e))
t:set("wireless",m.hidden.cfg,"auth",authentication:formvalue(e))
t:set("wireless",m.hidden.cfg,"identity",ident:formvalue(e)or"")
t:set("wireless",m.hidden.cfg,"password",wkey:formvalue(e)or"")
t:set("wireless",m.hidden.cfg,"ca_cert",cacert:formvalue(e)or"")
t:set("wireless",m.hidden.cfg,"client_cert",clientcert:formvalue(e)or"")
t:set("wireless",m.hidden.cfg,"priv_key",privkey:formvalue(e)or"")
t:set("wireless",m.hidden.cfg,"priv_key_pwd",privkeypwd:formvalue(e)or"")
elseif encr:formvalue(e)~="owe"then
t:set("wireless",m.hidden.cfg,"key",wkey:formvalue(e)or"")
end
if ciph and ciph:formvalue(e)and ciph:formvalue(e)~="auto"then
t:set("wireless",m.hidden.cfg,"encryption",encr:formvalue(e).."+"..ciph:formvalue(e))
else
t:set("wireless",m.hidden.cfg,"encryption",encr:formvalue(e))
end
end
if not t:get("travelmate",a)and cmd_list:formvalue(e)~="none"then
t:set("travelmate",a,"login")
end
if t:get("travelmate",a)then
t:set("travelmate",a,"command",cmd_list:formvalue(e))
t:set("travelmate",a,"command_args",cmd_args:formvalue(e))
t:save("travelmate")
t:commit("travelmate")
end
t:save("wireless")
t:commit("wireless")
luci.sys.call("env -i /bin/ubus call network reload >/dev/null 2>&1")
m.on_cancel()
end
return m
